#include "iodefine.h"
#include "slcd.h"
#include "rtc.h"

void SLCD_clear(void)
{
	unsigned int i;
	SLCD_init();
	SLCD_reset();
	SLCD_write(0xA0);
	for (i=0; i<16; i++) SLCD_write(0x00);	// \NA
}

void SLCD_clock(void)
{
	unsigned char a;
	SLCD_reset();
	SLCD_write(0xA0);
	
	a=byte2bcd(clock.ye);
	SLCD_1disp((a & 0xF0)>>4);
	SLCD_1disp(a & 0x0F);

	a=byte2bcd(clock.mn);
	SLCD_1disp(((a & 0xF0)>>4) | 0x80);
	SLCD_1disp(a & 0x0F);

	a=byte2bcd(clock.dy);
	SLCD_1disp(((a & 0xF0)>>4) | 0x80);
	SLCD_1disp(a & 0x0F);

	SLCD_write(0x00);
	SLCD_write(0x00);

	a=byte2bcd(clock.hh);
	SLCD_1disp((a & 0xF0)>>4);
	SLCD_1disp(a & 0x0F);

	a=byte2bcd(clock.mm);
	SLCD_1disp(((a & 0xF0)>>4) | 0x80);
	SLCD_1disp(a & 0x0F);

	a=byte2bcd(clock.ss);
	SLCD_1disp(((a & 0xF0)>>4) | 0x80);
	SLCD_1disp(a & 0x0F);
}

void SLCD_intdisp(unsigned int a,unsigned int b)
{
	char out[13];
	int i;
	
	out[0]=0;
	out[1]=0;
	out[2]=a/10000;
	a=a%10000;
	out[3]=a/1000;
	a=a%1000;
	out[4]=a/100;
	a=a%100;
	out[5]=a/10;
	out[6]=a%10;

	out[7]=0;
	out[8]=0;
	out[9]=b/10000;
	b=b%10000;
	out[10]=b/1000;
	b=b%1000;
	out[11]=b/100;
	b=b%100;
	out[12]=b/10;
	out[13]=b%10;

	SLCD_reset();
	SLCD_write(0xA0);

	for (i=0; i<14; i++) SLCD_1disp(out[i]);
	SLCD_write(0);
	SLCD_write(0);
	
}

void SLCD_1disp(unsigned char data)
{
	//                     0    1    2    3    4    5    6    7    8    9    A    b    C    d    E    F
	const char table[]={0x7D,0x05,0x5E,0x4F,0x27,0x6B,0x7B,0x45,0x7F,0x6F,0x77,0x3B,0x78,0x1F,0x7A,0x72};
	if (data < 0x10)
	{
		SLCD_write(table[data]);
	}
	else
	{
		data=data & 0x0F;
		SLCD_write(table[data] | 0x80);		// 4rbgɉĂA__
	}
}

void SLCD_write(char data)
{
	int i;
	SLCD_E=1;
	for (i=0; i<8; i++)
	{
		SLCD_DATA=((data >> 7)& 0x01);
		SLCD_clkout();
		data=data << 1;
	}
	SLCD_DATA=0;
}

void SLCD_clkout(void)
{
	int i;
	for (i=0; i<10; i++);
	SLCD_SCLK=1;
	for (i=0; i<10; i++);
	SLCD_SCLK=0;
}
	
void SLCD_reset(void)
{
	unsigned int i;
	SLCD_INT=1;
	for (i=0; i<10; i++);
	SLCD_INT=0;
	for (i=0; i<10; i++);
}

void SLCD_init(void)
{	
	int i;
	SLCD_INT=1;
	for (i=0; i<10; i++);
	SLCD_E=1;
	for (i=0; i<10; i++);
	SLCD_INT=0;
	for (i=0; i<10; i++);

	SLCD_reset();

	SLCD_DATA=1;
	SLCD_clkout();
	SLCD_DATA=0;
	SLCD_clkout();
	SLCD_clkout();
	SLCD_clkout();
	SLCD_clkout();
	SLCD_clkout();
	SLCD_clkout();
	SLCD_clkout();
	SLCD_clkout();
	SLCD_clkout();
	SLCD_DATA=1;
	SLCD_clkout();
	SLCD_clkout();
	SLCD_DATA=0;

	SLCD_reset();
	SLCD_reset();

	SLCD_DATA=1;
	SLCD_clkout();
	SLCD_DATA=0;
	SLCD_clkout();
	SLCD_clkout();
	SLCD_clkout();
	SLCD_clkout();
	SLCD_clkout();
	SLCD_clkout();
	SLCD_clkout();
	SLCD_clkout();
	SLCD_clkout();
	SLCD_DATA=1;
	SLCD_clkout();
	SLCD_clkout();
	SLCD_DATA=0;

	SLCD_reset();
	SLCD_reset();

	SLCD_DATA=1;
	SLCD_clkout();
	SLCD_DATA=0;
	SLCD_clkout();
	SLCD_clkout();
	SLCD_clkout();
	SLCD_clkout();
	SLCD_clkout();
	SLCD_clkout();
	SLCD_clkout();
	SLCD_clkout();
	SLCD_DATA=1;
	SLCD_clkout();
	SLCD_clkout();
	SLCD_clkout();
	SLCD_DATA=0;

	SLCD_reset();
	SLCD_reset();

	SLCD_DATA=1;
	SLCD_clkout();
	SLCD_DATA=0;
	SLCD_clkout();
	SLCD_clkout();
	SLCD_clkout();
	SLCD_clkout();
	SLCD_DATA=1;
	SLCD_clkout();
	SLCD_DATA=0;
	SLCD_clkout();
	SLCD_DATA=1;
	SLCD_clkout();
	SLCD_DATA=0;
	SLCD_clkout();
	SLCD_DATA=1;
	SLCD_clkout();
	SLCD_DATA=0;
	SLCD_clkout();
	SLCD_DATA=1;
	SLCD_clkout();
	SLCD_DATA=0;

	SLCD_reset();

	for (i=0; i<1000; i++);
}
