/***********************************************************************/
/*                                                                     */
/*  FILE        :test.c                                                */
/*  DATE        :Sun, Jan 06, 2008                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :H8S/2144F                                             */
/*                                                                     */
/*  This file is generated by Renesas Project Generator (Ver.4.9).     */
/*                                                                     */
/***********************************************************************/
                  


void main(void);
#ifdef __cplusplus
extern "C" {
void abort(void);
}
#endif

#include <no_float.h>
#include <stdio.h>

#include "iodefine.h"
#include "glcd.h"
#include "slcd.h"
#include "rtc.h"
#include "wdt0.h"
#include "eeprom.h"
#include "key.h"

void dispclock(void);
void timeadjust(void);
void laptimer(void);
void print_laptime(unsigned char,unsigned char, unsigned int);
void print_laptime_ul(unsigned char,unsigned char, unsigned int);
void SLCD_displaptime(unsigned int,unsigned int);
void wait(unsigned int);
unsigned char menu(char[][9]);



void main(void)
{
	unsigned int i,j,k;
	//RTC_reset();
	RTC_init();

	WDT0.WRITE.TCSR=0xA523;	// C^[o^C} vXP[ 1/512

	// uU[p ^C}[1ݒ
	MSTPCR.BIT._TMR01=0;	// TMR0/1 ̃W[Xgbv[h
	TMR1.TCORA=0xFF;
	TMR1.TCR.BIT.CCLR=1;	// RyA}b`AŃNA
	TMR1.TCSR.BIT.OS=3;		// RyA}b`A Ƃɔ]óigOój
	STCR.BIT.ICKS1=0;		//
	TMR1.TCR.BIT.CKS=0;

	cls();
	SLCD_clear();
	
	dispclock();
	while(1)
	{
	char MENU[][9]={
			"CLOCK   ",
			"LAPTIMER",
			"2       ",
			"3       ",
			"4       ",
			"5       ",
			"6       ",
			"TIME ADJ"
		};

		switch(menu(MENU))
		{
			case 0:
				dispclock();
				break;
			case 1:
				laptimer();
				break;
			case 7:
				timeadjust();
				break;
		}
	}
}

void laptimer(void)
{
	unsigned char i,count,keydata;
	unsigned char lap;
	unsigned char lapcount;
	unsigned int record[256];

	cls();
	SLCD_clear();
	laptime=0;
	lap=1;
	print(0,0,"Best");
	print_underline(0,1,"Lap     ");
	record[0]=60000;
	print_laptime(8,0,record[0]);
	
	while(1)
	{
		print_laptime_ul(8,1,laptime);
		SLCD_displaptime(record[0],laptime);
		
		keydata=keyin();
		if(keydata==0x10)
		{
			record[lap]=laptime;

			if(record[lap]<record[0])
			{
				record[0]=record[lap];
				print_laptime(8,0,record[0]);
			}

			count=2;
			for(i=lap; i>lap-5; i--)
			{
				print_laptime(8,count,record[i]);
				if(i==1) break;
				count++;
			}
			laptime=0;
			lap++;
		}
		if(keydata==0x20) break;
	}
	SLCD_clear();
}

void SLCD_displaptime(unsigned int best,unsigned int lap)
{
	SLCD_reset();
	SLCD_write(0xA0);

	SLCD_write(0);
	SLCD_1disp( best/60000);
	SLCD_1disp( best/6000%10);
	SLCD_1disp((best/100%60/10)|0x80);
	SLCD_1disp( best/100%10);
	SLCD_1disp((best%100/10)|0x80);
	SLCD_1disp( best%10);
	SLCD_write(0);
	SLCD_1disp( lap/60000);
	SLCD_1disp( lap/6000%10);
	SLCD_1disp((lap/100%60/10)|0x80);
	SLCD_1disp( lap/100%10);
	SLCD_1disp((lap%100/10)|0x80);
	SLCD_1disp( lap%10);
}

void print_laptime(unsigned char x,unsigned char y, unsigned int laptime)
{
		sprintf(msg,"%02d:%02d.%02d",laptime/6000
		                            ,laptime/100%60
									,laptime%100);
		print(x,y,msg);
}

void print_laptime_ul(unsigned char x,unsigned char y, unsigned int laptime)
{
		sprintf(msg,"%02d:%02d.%02d",laptime/6000
		                            ,laptime/100%60
									,laptime%100);
		print_underline(x,y,msg);
}

void dispclock(void)
{
	unsigned char keydata;
	cls();
	SLCD_clear();
	
	while(1)
	{
		SLCD_clock();
		
		sprintf(msg,"%02d/%02d/%02d(%s)",clock.ye,clock.mn,clock.dy,week[clock.we]);
		print(0,0,msg);
		
		sprintf(msg,"%02d:%02d:%02d",clock.hh,clock.mm,clock.ss);
		print(0,1,msg);
		
		sprintf(msg,"%9lu",timer);
		print(0,2,msg);
		
		//i=timer/10000000; // 1b҂
		//while(i==timer/10000000);

		keydata=keyin();
		if(keydata==0x10) break;
		if(keydata==0x20) break;
	}
	
	SLCD_clear();
}

void timeadjust(void)
{
	unsigned char item=0,flag=0,keydata,x,y;
	unsigned char data[7];
	unsigned int i;
	
	cls();

	data[0]=clock.ye;
	data[1]=clock.mn;
	data[2]=clock.dy;
	data[3]=clock.we;
	data[4]=clock.hh;
	data[5]=clock.mm;
	data[6]=clock.ss;

	sprintf(msg,"%02d/%02d/%02d(%s)",data[0],data[1],data[2],week[data[3]]);
	print(0,1,msg);
	sprintf(msg,"%02d:%02d:%02d",data[4],data[5],data[6]);
	print(0,2,msg);

	while(flag==0)
	{
		keydata=keyin();
		//sprintf(msg,"%02X",keydata);
		//print(0,7,msg);
	
		switch(keydata)
		{
			case 0x04:				// 
				if (item!=0) item--;
				break;
			case 0x08:				// E
				if (item!=6) item++;
				break;
			case 0x01:				// 
				data[item]++;
				if(data[0]>99) data[0]=0;
				if(data[1]>12) data[1]=1;
				if(data[2]>31) data[2]=1;
				if(data[3]> 6) data[3]=0;
				if(data[4]>23) data[4]=0;
				if(data[5]>59) data[5]=0;
				if(data[6]>59) data[6]=0;
				break;
			case 0x02:				// 
				if(data[item]!=0) data[item]--;
				else{
					if((item==0)&(data[0]==0)) data[0]=99;
					if((item==3)&(data[3]==0)) data[3]= 6;
					if((item==4)&(data[4]==0)) data[4]=23;
					if((item==5)&(data[5]==0)) data[5]=59;
					if((item==6)&(data[6]==0)) data[6]=59;
				}
				if((item==1)&(data[1]==0)) data[1]=12;
				if((item==2)&(data[2]==0)) data[2]=31;
				break;
			case 0x10:				// A
				flag=1;
				break;
			case 0x20:				// B
				flag=2;
				break;
		}

		if((keydata==0x04)||(keydata==0x08))	// EL[ꂽƂ
		{
		sprintf(msg,"%02d/%02d/%02d(%s)",data[0],data[1],data[2],week[data[3]]);
		print(0,1,msg);
		sprintf(msg,"%02d:%02d:%02d",data[4],data[5],data[6]);
		print(0,2,msg);
		}

		x=item*3;
		if(x>9)
		{
			y=2;
			x-=12;
		}
		else y=1;
	
		if(item==3) sprintf(msg,"%s",week[data[3]]);	// j
		else sprintf(msg,"%02d",data[item]);
		print_r(x,y,msg);
	}

	if(flag==1)		// {^
	{
		RTC_write(0xF,0x30);
		RTC_write(0x0,byte2bcd(data[6]));	// bJE^
		RTC_write(0x1,byte2bcd(data[5]));	// JE^
		RTC_write(0x2,byte2bcd(data[4]));	// JE^
		RTC_write(0x3,byte2bcd(data[3]));	// jJE^
		RTC_write(0x4,byte2bcd(data[2]));	// JE^
		RTC_write(0x5,byte2bcd(data[1]));	// JE^
		RTC_write(0x6,byte2bcd(data[0]));	// NJE^

		RTC_init();
	}
}

unsigned char menu(char MENU[8][9])
{
	unsigned int i;
	unsigned char item=0,selectitem=0xFF;

	for(i=0; i<8; i++)
	{
		print(0,i,"        |");		// j[8+1
	}
	
	while(selectitem==0xFF)
	{
		for (i=0; i<8; i++)
		{
			if(i==item)
			{
				print_r(0,i,MENU[i]);
			}
			else print(0,i,MENU[i]);
		}
	
		switch(keyin())
		{
			case 0x00:
				break;

			case 0x01:		// 
				if (item!=0) item--;
				break;

			case 0x02:		// 
				if (item<7) item++;
				break;

			case 0x08:		// E
				selectitem=item;
				break;

			case 0x10:		// A
				selectitem=item;
				break;
		}
	}
	return selectitem;
}

void wait(unsigned int a)
{
	unsigned int i,j;
	for (i=0; i<a; i++)
	{
		for (j=0; j<0x7fff; j++);
	}
}


#ifdef __cplusplus
void abort(void)
{

}
#endif
